package org.rcisoft.integration.aep.Controller;

import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.integration.aep.service.IAepPushService;
import org.rcisoft.integration.jieLink.dto.JieLinkResultDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@RequestMapping("/aep")
public class AepPushController {

    @Autowired
    private IAepPushService aepPushService;


    /**
     * 门磁推送数据接口
     * @param data
     * @return
     */
    @ApiOperation(value="AEP平台集成", notes="门磁数据订阅")
    @PostMapping(value = "/pushData")
    public JieLinkResultDto pushData(@RequestBody JSONObject data) {
        JieLinkResultDto result = new JieLinkResultDto();
        result.setCode("200");
        result.setMsg("接收成功");
        /**
         * {
         *     "upPacketSN": -1,
         *     "deviceType": "",
         *     "productId": "15450893",
         *     "IMEI": "869907059730560",
         *     "deviceId": "611ace87bfa440c2b4378b804aad9200",
         *     "protocol": "lwm2m",
         *     "messageType": "dataReport",
         *     "payload": {
         *         "APPdata": "QUE1NTAxMDMwQTAxMDAwMDAwMDAwMEQwMEMwMDAwRUI="
         *     },
         *     "assocAssetId": "",
         *     "tenantId": "2000144885",
         *     "IMSI": "undefined",
         *     "topic": "v1/up/ad",
         *     "upDataSN": -1,
         *     "serviceId": "",
         *     "timestamp": 1670289730649
         * }
         * {
         *     "upPacketSN": -1,
         *     "deviceType": "",
         *     "productId": "15450893",
         *     "IMEI": "869907059730560",
         *     "deviceId": "611ace87bfa440c2b4378b804aad9200",
         *     "protocol": "lwm2m",
         *     "messageType": "dataReport",
         *     "payload": {
         *         "APPdata": "QUE1NTAxMDMwQTAwMDAwMDAwMDAwMEQwMEMwMDAwRUE="
         *     },
         *     "assocAssetId": "",
         *     "tenantId": "2000144885",
         *     "IMSI": "undefined",
         *     "topic": "v1/up/ad",
         *     "upDataSN": -1,
         *     "serviceId": "",
         *     "timestamp": 1670289731890
         * }
         */
        log.info(data.toJSONString());
        aepPushService.saveDoorSensorData(data);
        return result;
    }

}
